Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 3864)
@@ -7073,193 +6977,313 @@
 !
 !-- Predetermine flag to mask topography
-    flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(:,j,i), 0 ) ) 
-    
-    DO  b = 1, nbins   ! aerosol size bins
-!             
-!--    Remove negative values 
-       aerosol_number(b)%conc(:,j,i) = MAX( nclim,                             &
-                                       aerosol_number(b)%conc(:,j,i) ) * flag
-       mcsum = 0.0_wp   ! total mass concentration 
-       DO  c = 1, ncc_tot
-!             
-!--       Remove negative concentrations 
-          aerosol_mass((c-1)*nbins+b)%conc(:,j,i) = MAX( mclim,                &
-                                     aerosol_mass((c-1)*nbins+b)%conc(:,j,i) ) &
-                                     * flag
-          mcsum = mcsum + aerosol_mass((c-1)*nbins+b)%conc(:,j,i) * flag
-       ENDDO         
-!                
-!--    Check that number and mass concentration match qualitatively 
-       IF ( ANY ( aerosol_number(b)%conc(:,j,i) > nclim  .AND.                 &
-                  mcsum <= 0.0_wp ) )                                          &
-       THEN
+    flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(:,j,i), 0 ) )
+
+    DO  ib = 1, nbins_aerosol   ! aerosol size bins
+!
+!--    Remove negative values
+       aerosol_number(ib)%conc(:,j,i) = MAX( nclim, aerosol_number(ib)%conc(:,j,i) ) * flag
+!
+!--    Calculate total mass concentration per bin
+       mcsum = 0.0_wp
+       DO  ic = 1, ncomponents_mass
+          icc = ( ic - 1 ) * nbins_aerosol + ib
+          mcsum = mcsum + aerosol_mass(icc)%conc(:,j,i) * flag
+       ENDDO
+!
+!--    Check that number and mass concentration match qualitatively
+       IF ( ANY ( aerosol_number(ib)%conc(:,j,i) > nclim  .AND. mcsum <= 0.0_wp ) )  THEN
           DO  k = nzb+1, nzt
-             IF ( aerosol_number(b)%conc(k,j,i) > nclim  .AND.                 &
-               mcsum(k) <= 0.0_wp ) &
-             THEN
-                aerosol_number(b)%conc(k,j,i) = nclim * flag(k)
-                DO  c = 1, ncc_tot
-                   aerosol_mass((c-1)*nbins+b)%conc(k,j,i) = mclim * flag(k)
+             IF ( aerosol_number(ib)%conc(k,j,i) > nclim  .AND. mcsum(k) <= 0.0_wp )  THEN
+                aerosol_number(ib)%conc(k,j,i) = nclim * flag(k)
+                DO  ic = 1, ncomponents_mass
+                   icc = ( ic - 1 ) * nbins_aerosol + ib
+                   aerosol_mass(icc)%conc(k,j,i) = mclim * flag(k)
                 ENDDO
              ENDIF
           ENDDO
        ENDIF
-!             
+!
 !--    Update aerosol particle radius
-       CALL bin_mixrat( 'dry', b, i, j, zvol )
+       CALL bin_mixrat( 'dry', ib, i, j, zvol )
        zvol = zvol / arhoh2so4    ! Why on sulphate?
-!                   
-!--    Particles smaller then 0.1 nm diameter are set to zero 
-       zddry = ( zvol / MAX( nclim, aerosol_number(b)%conc(:,j,i) ) / api6 )** &
-               ( 1.0_wp / 3.0_wp )
-       flag_zddry = MERGE( 1.0_wp, 0.0_wp, ( zddry < 1.0E-10_wp  .AND.         &
-                                       aerosol_number(b)%conc(:,j,i) > nclim ) )
-!                   
+!
+!--    Particles smaller then 0.1 nm diameter are set to zero
+       zddry = ( zvol / MAX( nclim, aerosol_number(ib)%conc(:,j,i) ) / api6 )**0.33333333_wp
+       flag_zddry = MERGE( 1.0_wp, 0.0_wp, ( zddry < 1.0E-10_wp  .AND.                             &
+                           aerosol_number(ib)%conc(:,j,i) > nclim ) )
+!
 !--    Volatile species to the gas phase
-       IF ( is_used( prtcl, 'SO4' ) .AND. lscndgas )  THEN
-          nc = get_index( prtcl, 'SO4' )
-          c = ( nc - 1 ) * nbins + b                      
+       IF ( index_so4 > 0 .AND. lscndgas )  THEN
+          ic = ( index_so4 - 1 ) * nbins_aerosol + ib
           IF ( salsa_gases_from_chem )  THEN
-             chem_species( gas_index_chem(1) )%conc(:,j,i) =                   &
-                               chem_species( gas_index_chem(1) )%conc(:,j,i) + &
-                               aerosol_mass(c)%conc(:,j,i) * avo * flag *      &
-                               flag_zddry / ( amh2so4 * ppm_to_nconc ) 
+             ig = gas_index_chem(1)
+             chem_species(ig)%conc(:,j,i) = chem_species(ig)%conc(:,j,i) +                         &
+                                            aerosol_mass(ic)%conc(:,j,i) * avo * flag_zddry /      &
+                                            ( amh2so4 * ppm_to_nconc ) * flag
           ELSE
-             salsa_gas(1)%conc(:,j,i) = salsa_gas(1)%conc(:,j,i) +             &
-                                        aerosol_mass(c)%conc(:,j,i) / amh2so4 *&
-                                        avo * flag * flag_zddry
+             salsa_gas(1)%conc(:,j,i) = salsa_gas(1)%conc(:,j,i) + aerosol_mass(ic)%conc(:,j,i) /  &
+                                        amh2so4 * avo * flag_zddry * flag
           ENDIF
        ENDIF
-       IF ( is_used( prtcl, 'OC' )  .AND.  lscndgas )  THEN
-          nc = get_index( prtcl, 'OC' )
-          c = ( nc - 1 ) * nbins + b
+       IF ( index_oc > 0  .AND.  lscndgas )  THEN
+          ic = ( index_oc - 1 ) * nbins_aerosol + ib
           IF ( salsa_gases_from_chem )  THEN
-             chem_species( gas_index_chem(5) )%conc(:,j,i) =                   &
-                               chem_species( gas_index_chem(5) )%conc(:,j,i) + &
-                               aerosol_mass(c)%conc(:,j,i) * avo * flag *      &
-                               flag_zddry / ( amoc * ppm_to_nconc ) 
-          ELSE                         
-             salsa_gas(5)%conc(:,j,i) = salsa_gas(5)%conc(:,j,i) + &
-                                        aerosol_mass(c)%conc(:,j,i) / amoc *   &
-                                        avo * flag * flag_zddry
+             ig = gas_index_chem(5)
+             chem_species(ig)%conc(:,j,i) = chem_species(ig)%conc(:,j,i) +                         &
+                                            aerosol_mass(ic)%conc(:,j,i) * avo * flag_zddry /      &
+                                            ( amoc * ppm_to_nconc ) * flag
+          ELSE
+             salsa_gas(5)%conc(:,j,i) = salsa_gas(5)%conc(:,j,i) + aerosol_mass(ic)%conc(:,j,i) /  &
+                                        amoc * avo * flag_zddry * flag
           ENDIF
        ENDIF
-       IF ( is_used( prtcl, 'NO' )  .AND.  lscndgas )  THEN
-          nc = get_index( prtcl, 'NO' )
-          c = ( nc - 1 ) * nbins + b                      
+       IF ( index_no > 0  .AND.  lscndgas )  THEN
+          ic = ( index_no - 1 ) * nbins_aerosol + ib
           IF ( salsa_gases_from_chem )  THEN
-                chem_species( gas_index_chem(2) )%conc(:,j,i) =                &
-                               chem_species( gas_index_chem(2) )%conc(:,j,i) + &
-                               aerosol_mass(c)%conc(:,j,i) * avo * flag *      &
-                               flag_zddry / ( amhno3 * ppm_to_nconc )                   
+             ig = gas_index_chem(2)
+             chem_species(ig)%conc(:,j,i) = chem_species(ig)%conc(:,j,i) +                         &
+                                            aerosol_mass(ic)%conc(:,j,i) * avo * flag_zddry /      &
+                                            ( amhno3 * ppm_to_nconc ) *flag
           ELSE
-             salsa_gas(2)%conc(:,j,i) = salsa_gas(2)%conc(:,j,i) +             &
-                                        aerosol_mass(c)%conc(:,j,i) / amhno3 * &
-                                        avo * flag * flag_zddry
+             salsa_gas(2)%conc(:,j,i) = salsa_gas(2)%conc(:,j,i) + aerosol_mass(ic)%conc(:,j,i) /  &
+                                        amhno3 * avo * flag_zddry * flag
           ENDIF
        ENDIF
-       IF ( is_used( prtcl, 'NH' )  .AND.  lscndgas )  THEN
-          nc = get_index( prtcl, 'NH' )
-          c = ( nc - 1 ) * nbins + b                      
+       IF ( index_nh > 0  .AND.  lscndgas )  THEN
+          ic = ( index_nh - 1 ) * nbins_aerosol + ib
           IF ( salsa_gases_from_chem )  THEN
-                chem_species( gas_index_chem(3) )%conc(:,j,i) =                &
-                               chem_species( gas_index_chem(3) )%conc(:,j,i) + &
-                               aerosol_mass(c)%conc(:,j,i) * avo * flag *      &
-                               flag_zddry / ( amnh3 * ppm_to_nconc )                         
+             ig = gas_index_chem(3)
+             chem_species(ig)%conc(:,j,i) = chem_species(ig)%conc(:,j,i) +                         &
+                                            aerosol_mass(ic)%conc(:,j,i) * avo * flag_zddry /      &
+                                            ( amnh3 * ppm_to_nconc ) *flag
           ELSE
-             salsa_gas(3)%conc(:,j,i) = salsa_gas(3)%conc(:,j,i) +             &
-                                        aerosol_mass(c)%conc(:,j,i) / amnh3 *  &
-                                        avo * flag * flag_zddry
+             salsa_gas(3)%conc(:,j,i) = salsa_gas(3)%conc(:,j,i) + aerosol_mass(ic)%conc(:,j,i) /  &
+                                        amnh3 * avo * flag_zddry *flag
           ENDIF
        ENDIF
-!                      
+!
 !--    Mass and number to zero (insoluble species and water are lost)
-       DO  c = 1, ncc_tot
-          aerosol_mass((c-1)*nbins+b)%conc(:,j,i) = MERGE( mclim * flag,       &
-                                      aerosol_mass((c-1)*nbins+b)%conc(:,j,i), &
-                                      flag_zddry > 0.0_wp )
+       DO  ic = 1, ncomponents_mass
+          icc = ( ic - 1 ) * nbins_aerosol + ib
+          aerosol_mass(icc)%conc(:,j,i) = MERGE( mclim * flag, aerosol_mass(icc)%conc(:,j,i),      &
+                                                 flag_zddry > 0.0_wp )
        ENDDO
-       aerosol_number(b)%conc(:,j,i) = MERGE( nclim * flag,                    &
-                                              aerosol_number(b)%conc(:,j,i),   &
-                                              flag_zddry > 0.0_wp )       
-       Ra_dry(:,j,i,b) = MAX( 1.0E-10_wp, 0.5_wp * zddry )      
-       
+       aerosol_number(ib)%conc(:,j,i) = MERGE( nclim, aerosol_number(ib)%conc(:,j,i),              &
+                                               flag_zddry > 0.0_wp )
+       ra_dry(:,j,i,ib) = MAX( 1.0E-10_wp, 0.5_wp * zddry )
+
     ENDDO
     IF ( .NOT. salsa_gases_from_chem )  THEN
-       DO  gt = 1, ngast
-          salsa_gas(gt)%conc(:,j,i) = MAX( nclim, salsa_gas(gt)%conc(:,j,i) )  &
-                                      * flag
+       DO  ig = 1, ngases_salsa
+          salsa_gas(ig)%conc(:,j,i) = MAX( nclim, salsa_gas(ig)%conc(:,j,i) ) * flag
        ENDDO
     ENDIF
-    
+
     CALL cpu_log( log_point_s(94), 'salsa diagnostics ', 'stop' )
 
  END SUBROUTINE salsa_diagnostics
 
- 
-! 
+!
 !------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Calculate the tendencies for aerosol number and mass concentrations. 
+!> Calculate the prognostic equation for aerosol number and mass, and gas
+!> concentrations. Cache-optimized.
+!------------------------------------------------------------------------------!
+ SUBROUTINE salsa_prognostic_equations_ij( i, j, i_omp_start, tn )
+
+    USE control_parameters,                                                                        &
+        ONLY:  time_since_reference_point
+
+    USE salsa_util_mod,                                                                            &
+        ONLY:  sums_salsa_ws_l
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) ::  i            !<
+    INTEGER(iwp) ::  i_omp_start  !<
+    INTEGER(iwp) ::  ib           !< loop index for aerosol number bin OR gas index
+    INTEGER(iwp) ::  ic           !< loop index for aerosol mass bin
+    INTEGER(iwp) ::  icc          !< (c-1)*nbins_aerosol+b
+    INTEGER(iwp) ::  ig           !< loop index for salsa gases
+    INTEGER(iwp) ::  j            !<
+    INTEGER(iwp) ::  tn           !<
+
+    LOGICAL ::  sedim  !< calculate sedimentation only for aerosols (number and mass)
+
+    IF ( time_since_reference_point >= skip_time_do_salsa )  THEN
+!
+!--    Aerosol number
+       DO  ib = 1, nbins_aerosol
+          sums_salsa_ws_l = aerosol_number(ib)%sums_ws_l
+          CALL salsa_tendency( 'aerosol_number', aerosol_number(ib)%conc_p, aerosol_number(ib)%conc,&
+                               aerosol_number(ib)%tconc_m, i, j, i_omp_start, tn, ib, ib,          &
+                               aerosol_number(ib)%flux_s, aerosol_number(ib)%diss_s,               &
+                               aerosol_number(ib)%flux_l, aerosol_number(ib)%diss_l,               &
+                               aerosol_number(ib)%init, sedim )
+          aerosol_number(ib)%sums_ws_l = sums_salsa_ws_l
+!
+!--       Aerosol mass
+          DO  ic = 1, ncomponents_mass
+             icc = ( ic - 1 ) * nbins_aerosol + ib
+             sums_salsa_ws_l = aerosol_mass(icc)%sums_ws_l
+             CALL salsa_tendency( 'aerosol_mass', aerosol_mass(icc)%conc_p, aerosol_mass(icc)%conc,&
+                                  aerosol_mass(icc)%tconc_m, i, j, i_omp_start, tn, ib, ic,        &
+                                  aerosol_mass(icc)%flux_s, aerosol_mass(icc)%diss_s,              &
+                                  aerosol_mass(icc)%flux_l, aerosol_mass(icc)%diss_l,              &
+                                  aerosol_mass(icc)%init, sedim )
+             aerosol_mass(icc)%sums_ws_l = sums_salsa_ws_l
+
+          ENDDO  ! ic
+       ENDDO  ! ib
+!
+!--    Gases
+       IF ( .NOT. salsa_gases_from_chem )  THEN
+
+          DO  ig = 1, ngases_salsa
+             sums_salsa_ws_l = salsa_gas(ig)%sums_ws_l
+             CALL salsa_tendency( 'salsa_gas', salsa_gas(ig)%conc_p, salsa_gas(ig)%conc,           &
+                                  salsa_gas(ig)%tconc_m, i, j, i_omp_start, tn, ig, ig,            &
+                                  salsa_gas(ig)%flux_s, salsa_gas(ig)%diss_s, salsa_gas(ig)%flux_l,&
+                                  salsa_gas(ig)%diss_l, salsa_gas(ig)%init, sedim )
+             salsa_gas(ig)%sums_ws_l = sums_salsa_ws_l
+
+          ENDDO  ! ig
+
+       ENDIF
+
+    ENDIF
+
+ END SUBROUTINE salsa_prognostic_equations_ij
+!
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Calculate the prognostic equation for aerosol number and mass, and gas
+!> concentrations. Cache-optimized.
+!------------------------------------------------------------------------------!
+ SUBROUTINE salsa_prognostic_equations()
+
+    USE control_parameters,                                                                        &
+        ONLY:  time_since_reference_point
+
+    USE salsa_util_mod,                                                                            &
+        ONLY:  sums_salsa_ws_l
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) ::  ib           !< loop index for aerosol number bin OR gas index
+    INTEGER(iwp) ::  ic           !< loop index for aerosol mass bin
+    INTEGER(iwp) ::  icc          !< (c-1)*nbins_aerosol+b
+    INTEGER(iwp) ::  ig           !< loop index for salsa gases
+
+    LOGICAL ::  sedim  !< calculate sedimentation only for aerosols (number and mass)
+
+    IF ( time_since_reference_point >= skip_time_do_salsa )  THEN
+!
+!--    Aerosol number
+       DO  ib = 1, nbins_aerosol
+          sums_salsa_ws_l = aerosol_number(ib)%sums_ws_l
+          CALL salsa_tendency( 'aerosol_number', aerosol_number(ib)%conc_p, aerosol_number(ib)%conc,&
+                               aerosol_number(ib)%tconc_m, ib, ib, aerosol_number(ib)%init, sedim )
+          aerosol_number(ib)%sums_ws_l = sums_salsa_ws_l
+!
+!--       Aerosol mass
+          DO  ic = 1, ncomponents_mass
+             icc = ( ic - 1 ) * nbins_aerosol + ib
+             sums_salsa_ws_l = aerosol_mass(icc)%sums_ws_l
+             CALL salsa_tendency( 'aerosol_mass', aerosol_mass(icc)%conc_p, aerosol_mass(icc)%conc,&
+                                  aerosol_mass(icc)%tconc_m, ib, ic, aerosol_mass(icc)%init, sedim )
+             aerosol_mass(icc)%sums_ws_l = sums_salsa_ws_l
+
+          ENDDO  ! ic
+       ENDDO  ! ib
+!
+!--    Gases
+       IF ( .NOT. salsa_gases_from_chem )  THEN
+
+          DO  ig = 1, ngases_salsa
+             sums_salsa_ws_l = salsa_gas(ig)%sums_ws_l
+             CALL salsa_tendency( 'salsa_gas', salsa_gas(ig)%conc_p, salsa_gas(ig)%conc,           &
+                                  salsa_gas(ig)%tconc_m, ig, ig, salsa_gas(ig)%init, sedim )
+             salsa_gas(ig)%sums_ws_l = sums_salsa_ws_l
+
+          ENDDO  ! ig
+
+       ENDIF
+
+    ENDIF
+
+ END SUBROUTINE salsa_prognostic_equations
+!
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Tendencies for aerosol number and mass and gas concentrations.
 !> Cache-optimized.
-!------------------------------------------------------------------------------! 
- SUBROUTINE salsa_tendency_ij( id, rs_p, rs, trs_m, i, j, i_omp_start, tn, b,  &
-                               c, flux_s, diss_s, flux_l, diss_l, rs_init )
-    
-    USE advec_ws,                                                              &
-        ONLY:  advec_s_ws 
-    USE advec_s_pw_mod,                                                        &
+!------------------------------------------------------------------------------!
+ SUBROUTINE salsa_tendency_ij( id, rs_p, rs, trs_m, i, j, i_omp_start, tn, ib, ic, flux_s, diss_s, &
+                               flux_l, diss_l, rs_init, do_sedimentation )
+
+    USE advec_ws,                                                                                  &
+        ONLY:  advec_s_ws
+
+    USE advec_s_pw_mod,                                                                            &
         ONLY:  advec_s_pw
-    USE advec_s_up_mod,                                                        &
+
+    USE advec_s_up_mod,                                                                            &
         ONLY:  advec_s_up
-    USE arrays_3d,                                                             &
+
+    USE arrays_3d,                                                                                 &
         ONLY:  ddzu, rdf_sc, tend
-    USE diffusion_s_mod,                                                       &
+
+    USE diffusion_s_mod,                                                                           &
         ONLY:  diffusion_s
-    USE indices,                                                               &
+
+    USE indices,                                                                                   &
         ONLY:  wall_flags_0
-    USE pegrid,                                                                &
+
+    USE pegrid,                                                                                    &
         ONLY:  threads_per_task
-    USE surface_mod,                                                           &
-        ONLY :  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h,    &
-                                 surf_usm_v
-    
+
+    USE surface_mod,                                                                               &
+        ONLY :  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h, surf_usm_v
+
     IMPLICIT NONE
-    
-    CHARACTER (LEN = *) ::  id
-    INTEGER(iwp) ::  b   !< bin index in derived type aerosol_size_bin    
-    INTEGER(iwp) ::  c   !< bin index in derived type aerosol_size_bin    
-    INTEGER(iwp) ::  i   !<
-    INTEGER(iwp) ::  i_omp_start !<
-    INTEGER(iwp) ::  j   !<
-    INTEGER(iwp) ::  k   !< 
-    INTEGER(iwp) ::  nc  !< (c-1)*nbins+b
-    INTEGER(iwp) ::  tn  !<
+
+    CHARACTER(LEN = *) ::  id  !<
+
+    INTEGER(iwp) ::  i            !<
+    INTEGER(iwp) ::  i_omp_start  !<
+    INTEGER(iwp) ::  ib           !< loop index for aerosol number bin OR gas index
+    INTEGER(iwp) ::  ic           !< loop index for aerosol mass bin
+    INTEGER(iwp) ::  icc          !< (c-1)*nbins_aerosol+b
+    INTEGER(iwp) ::  j            !<
+    INTEGER(iwp) ::  k            !<
+    INTEGER(iwp) ::  tn           !<
+
+    LOGICAL ::  do_sedimentation  !<
+
+    REAL(wp), DIMENSION(nzb:nzt+1) ::  rs_init  !<
+
+    REAL(wp), DIMENSION(nzb+1:nzt,0:threads_per_task-1) ::  diss_s  !<
+    REAL(wp), DIMENSION(nzb+1:nzt,0:threads_per_task-1) ::  flux_s  !<
+
     REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn,0:threads_per_task-1) ::  diss_l  !<
-    REAL(wp), DIMENSION(nzb+1:nzt,0:threads_per_task-1)         ::  diss_s  !<
     REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn,0:threads_per_task-1) ::  flux_l  !<
-    REAL(wp), DIMENSION(nzb+1:nzt,0:threads_per_task-1)         ::  flux_s  !< 
-    REAL(wp), DIMENSION(nzb:nzt+1)                              ::  rs_init !<
-    REAL(wp), DIMENSION(:,:,:), POINTER                         ::  rs_p    !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER                         ::  rs      !<
-    REAL(wp), DIMENSION(:,:,:), POINTER                         ::  trs_m   !<
-    
-    nc = (c-1)*nbins+b    
+
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  rs_p    !<
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  rs      !<
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  trs_m   !<
+
+    icc = ( ic - 1 ) * nbins_aerosol + ib
 !
 !-- Tendency-terms for reactive scalar
     tend(:,j,i) = 0.0_wp
-    
-    IF ( id == 'aerosol_number'  .AND.  lod_aero == 3 )  THEN
-       tend(:,j,i) = tend(:,j,i) + aerosol_number(b)%source(:,j,i)
-    ELSEIF ( id == 'aerosol_mass'  .AND.  lod_aero == 3 )  THEN
-       tend(:,j,i) = tend(:,j,i) + aerosol_mass(nc)%source(:,j,i)
-    ENDIF
-!    
+!
 !-- Advection terms
     IF ( timestep_scheme(1:5) == 'runge' )  THEN
        IF ( ws_scheme_sca )  THEN
-          CALL advec_s_ws( i, j, rs, id, flux_s, diss_s, flux_l, diss_l,       &
-                           i_omp_start, tn )
+          CALL advec_s_ws( i, j, rs, id, flux_s, diss_s, flux_l, diss_l, i_omp_start, tn )
        ELSE
           CALL advec_s_pw( i, j, rs )
@@ -7269,67 +7293,53 @@
     ENDIF
 !
-!-- Diffusion terms    
-    IF ( id == 'aerosol_number' )  THEN
-       CALL diffusion_s( i, j, rs,                   surf_def_h(0)%answs(:,b), &
-                           surf_def_h(1)%answs(:,b), surf_def_h(2)%answs(:,b), &
-                           surf_lsm_h%answs(:,b),    surf_usm_h%answs(:,b),    &
-                           surf_def_v(0)%answs(:,b), surf_def_v(1)%answs(:,b), &
-                           surf_def_v(2)%answs(:,b), surf_def_v(3)%answs(:,b), &
-                           surf_lsm_v(0)%answs(:,b), surf_lsm_v(1)%answs(:,b), &
-                           surf_lsm_v(2)%answs(:,b), surf_lsm_v(3)%answs(:,b), &
-                           surf_usm_v(0)%answs(:,b), surf_usm_v(1)%answs(:,b), &
-                           surf_usm_v(2)%answs(:,b), surf_usm_v(3)%answs(:,b) )
-!
-!--    Sedimentation for aerosol number and mass
-       IF ( lsdepo )  THEN
-          tend(nzb+1:nzt,j,i) = tend(nzb+1:nzt,j,i) - MAX( 0.0_wp,             &
-                         ( rs(nzb+2:nzt+1,j,i) * sedim_vd(nzb+2:nzt+1,j,i,b) - &
-                           rs(nzb+1:nzt,j,i) * sedim_vd(nzb+1:nzt,j,i,b) ) *   &
-                         ddzu(nzb+1:nzt) ) * MERGE( 1.0_wp, 0.0_wp,            &
-                         BTEST( wall_flags_0(nzb:nzt-1,j,i), 0 ) )
-       ENDIF
-       
-    ELSEIF ( id == 'aerosol_mass' )  THEN
-       CALL diffusion_s( i, j, rs,                  surf_def_h(0)%amsws(:,nc), & 
-                         surf_def_h(1)%amsws(:,nc), surf_def_h(2)%amsws(:,nc), &
-                         surf_lsm_h%amsws(:,nc),    surf_usm_h%amsws(:,nc),    &
-                         surf_def_v(0)%amsws(:,nc), surf_def_v(1)%amsws(:,nc), &
-                         surf_def_v(2)%amsws(:,nc), surf_def_v(3)%amsws(:,nc), &
-                         surf_lsm_v(0)%amsws(:,nc), surf_lsm_v(1)%amsws(:,nc), &
-                         surf_lsm_v(2)%amsws(:,nc), surf_lsm_v(3)%amsws(:,nc), &
-                         surf_usm_v(0)%amsws(:,nc), surf_usm_v(1)%amsws(:,nc), &
-                         surf_usm_v(2)%amsws(:,nc), surf_usm_v(3)%amsws(:,nc) ) 
-!
-!--    Sedimentation for aerosol number and mass
-       IF ( lsdepo )  THEN
-          tend(nzb+1:nzt,j,i) = tend(nzb+1:nzt,j,i) - MAX( 0.0_wp,             &
-                         ( rs(nzb+2:nzt+1,j,i) * sedim_vd(nzb+2:nzt+1,j,i,b) - &
-                           rs(nzb+1:nzt,j,i) * sedim_vd(nzb+1:nzt,j,i,b) ) *   &
-                         ddzu(nzb+1:nzt) ) * MERGE( 1.0_wp, 0.0_wp,            &
-                         BTEST( wall_flags_0(nzb:nzt-1,j,i), 0 ) )
-       ENDIF                         
-    ELSEIF ( id == 'salsa_gas' )  THEN
-       CALL diffusion_s( i, j, rs,                   surf_def_h(0)%gtsws(:,b), &
-                           surf_def_h(1)%gtsws(:,b), surf_def_h(2)%gtsws(:,b), &
-                           surf_lsm_h%gtsws(:,b),    surf_usm_h%gtsws(:,b),    &
-                           surf_def_v(0)%gtsws(:,b), surf_def_v(1)%gtsws(:,b), &
-                           surf_def_v(2)%gtsws(:,b), surf_def_v(3)%gtsws(:,b), &
-                           surf_lsm_v(0)%gtsws(:,b), surf_lsm_v(1)%gtsws(:,b), &
-                           surf_lsm_v(2)%gtsws(:,b), surf_lsm_v(3)%gtsws(:,b), &
-                           surf_usm_v(0)%gtsws(:,b), surf_usm_v(1)%gtsws(:,b), &
-                           surf_usm_v(2)%gtsws(:,b), surf_usm_v(3)%gtsws(:,b) ) 
+!-- Diffusion terms
+    SELECT CASE ( id )
+       CASE ( 'aerosol_number' )
+          CALL diffusion_s( i, j, rs, surf_def_h(0)%answs(:,ib),                                   &
+                                      surf_def_h(1)%answs(:,ib), surf_def_h(2)%answs(:,ib),        &
+                                      surf_lsm_h%answs(:,ib),    surf_usm_h%answs(:,ib),           &
+                                      surf_def_v(0)%answs(:,ib), surf_def_v(1)%answs(:,ib),        &
+                                      surf_def_v(2)%answs(:,ib), surf_def_v(3)%answs(:,ib),        &
+                                      surf_lsm_v(0)%answs(:,ib), surf_lsm_v(1)%answs(:,ib),        &
+                                      surf_lsm_v(2)%answs(:,ib), surf_lsm_v(3)%answs(:,ib),        &
+                                      surf_usm_v(0)%answs(:,ib), surf_usm_v(1)%answs(:,ib),        &
+                                      surf_usm_v(2)%answs(:,ib), surf_usm_v(3)%answs(:,ib) )
+       CASE ( 'aerosol_mass' )
+          CALL diffusion_s( i, j, rs, surf_def_h(0)%amsws(:,icc),                                  &
+                                      surf_def_h(1)%amsws(:,icc), surf_def_h(2)%amsws(:,icc),      &
+                                      surf_lsm_h%amsws(:,icc),    surf_usm_h%amsws(:,icc),         &
+                                      surf_def_v(0)%amsws(:,icc), surf_def_v(1)%amsws(:,icc),      &
+                                      surf_def_v(2)%amsws(:,icc), surf_def_v(3)%amsws(:,icc),      &
+                                      surf_lsm_v(0)%amsws(:,icc), surf_lsm_v(1)%amsws(:,icc),      &
+                                      surf_lsm_v(2)%amsws(:,icc), surf_lsm_v(3)%amsws(:,icc),      &
+                                      surf_usm_v(0)%amsws(:,icc), surf_usm_v(1)%amsws(:,icc),      &
+                                      surf_usm_v(2)%amsws(:,icc), surf_usm_v(3)%amsws(:,icc) )
+       CASE ( 'salsa_gas' )
+          CALL diffusion_s( i, j, rs, surf_def_h(0)%gtsws(:,ib),                                   &
+                                      surf_def_h(1)%gtsws(:,ib), surf_def_h(2)%gtsws(:,ib),        &
+                                      surf_lsm_h%gtsws(:,ib), surf_usm_h%gtsws(:,ib),              &
+                                      surf_def_v(0)%gtsws(:,ib), surf_def_v(1)%gtsws(:,ib),        &
+                                      surf_def_v(2)%gtsws(:,ib), surf_def_v(3)%gtsws(:,ib),        &
+                                      surf_lsm_v(0)%gtsws(:,ib), surf_lsm_v(1)%gtsws(:,ib),        &
+                                      surf_lsm_v(2)%gtsws(:,ib), surf_lsm_v(3)%gtsws(:,ib),        &
+                                      surf_usm_v(0)%gtsws(:,ib), surf_usm_v(1)%gtsws(:,ib),        &
+                                      surf_usm_v(2)%gtsws(:,ib), surf_usm_v(3)%gtsws(:,ib) )
+    END SELECT
+!
+!-- Sedimentation for aerosol number and mass
+    IF ( lsdepo  .AND.  do_sedimentation )  THEN
+       tend(nzb+1:nzt,j,i) = tend(nzb+1:nzt,j,i) - MAX( 0.0_wp,                                    &
+                             ( rs(nzb+2:nzt+1,j,i) * sedim_vd(nzb+2:nzt+1,j,i,ib) -                &
+                               rs(nzb+1:nzt,j,i) * sedim_vd(nzb+1:nzt,j,i,ib) ) * ddzu(nzb+1:nzt) )&
+                             * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(nzb:nzt-1,j,i), 0 ) )
     ENDIF
 !
 !-- Prognostic equation for a scalar
     DO  k = nzb+1, nzt
-       rs_p(k,j,i) = rs(k,j,i) +  ( dt_3d  * ( tsc(2) * tend(k,j,i) +          &
-                                               tsc(3) * trs_m(k,j,i) )         &
-                                             - tsc(5) * rdf_sc(k)              &
-                                           * ( rs(k,j,i) - rs_init(k) ) )      &
-                                  * MERGE( 1.0_wp, 0.0_wp,                     &
-                                           BTEST( wall_flags_0(k,j,i), 0 ) )
-       IF ( rs_p(k,j,i) < 0.0_wp )  rs_p(k,j,i) = 0.1_wp * rs(k,j,i) 
+       rs_p(k,j,i) = rs(k,j,i) + ( dt_3d * ( tsc(2) * tend(k,j,i) + tsc(3) * trs_m(k,j,i) )        &
+                                           - tsc(5) * rdf_sc(k) * ( rs(k,j,i) - rs_init(k) ) )     &
+                                 * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
+       IF ( rs_p(k,j,i) < 0.0_wp )  rs_p(k,j,i) = 0.1_wp * rs(k,j,i)
     ENDDO
-
 !
 !-- Calculate tendencies for the next Runge-Kutta step
@@ -7339,6 +7349,5 @@
              trs_m(k,j,i) = tend(k,j,i)
           ENDDO
-       ELSEIF ( intermediate_timestep_count < &
-                intermediate_timestep_count_max )  THEN
+       ELSEIF ( intermediate_timestep_count < intermediate_timestep_count_max )  THEN
           DO  k = nzb+1, nzt
              trs_m(k,j,i) = -9.5625_wp * tend(k,j,i) + 5.3125_wp * trs_m(k,j,i)
